#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

uint32_t read_32_be(unsigned char *b)
{
    uint32_t t = 0;
    for (int i = 0; i < 4; i++)
    {
        t *= 0x100;
        t += b[i];
    }

    return t;
}

int main(int argc, char **argv)
{
    if (argc != 3) exit(EXIT_FAILURE);
    
    FILE *infile = fopen(argv[1], "rb");
    if (!infile) exit(EXIT_FAILURE);

    FILE *outfile = fopen(argv[2], "wb");
    if (!outfile) exit(EXIT_FAILURE);

    unsigned char head_buf[12];
    unsigned char buf[0x800];

    int done = 0;

    while (!done)
    {
        if ( fread(head_buf, 1, 12, infile) != 12) exit(EXIT_FAILURE);

        if (head_buf[0] == 0x80)
        {
            done = 1;
            head_buf[0] = 0;
        }

        uint32_t block_size = read_32_be(&head_buf[0]);
        if (block_size < 12) exit(EXIT_FAILURE);

        if (fread(buf, 1, block_size-12, infile) != block_size-12) exit(EXIT_FAILURE);
        if (fwrite(buf, 1, 0x800, outfile) != 0x800) exit(EXIT_FAILURE);
    }

    printf("Done!\n");

    return 0;
}
